using e_suite.API.Common.models;
using e_suite.Utilities.Pagination;
using Microsoft.AspNetCore.Mvc;
using Moq;
using NUnit.Framework;

namespace eSuite.API.UnitTests.Controllers.DomainControllerUnitTests;

[TestFixture]
public class GetDomainsUnitTests : DomainControllerTestBase
{
    [SetUp]
    public override async Task Setup()
    {
        await base.Setup();
    }

    [Test]
    public async Task GetDomains_WhenCalled_ReturnsPagedData()
    {
        //Arrange
        var domains = new List<GetDomain>
        {
            new()
            {
                Guid = new Guid("16241e96-9062-4221-b073-a48330b2cc9b"),
                Id = 999,
                Name = "Some domain"
            }
        };

        var paginatedData = new PaginatedData<GetDomain>
        {
            Count = domains.Count,
            Data = domains,
            Page = 1,
            PageSize = 10
        };

        var cancellationToken = CancellationToken.None;

        _domainManagerMock.Setup(x => x.GetDomainsAsync(It.IsAny<Paging>(), cancellationToken)).ReturnsAsync(paginatedData);

        //Act
        var actualResult = await _domainController.GetDomains(new Paging(), cancellationToken);

        //Assert
        Assert.That(actualResult.GetType(), Is.EqualTo(typeof(OkObjectResult)));
        var objectResult = actualResult as OkObjectResult;

        Assert.That(objectResult?.StatusCode, Is.EqualTo(200));
        Assert.That(objectResult?.Value, Is.Not.Null);
        Assert.That(objectResult!.Value!.GetType, Is.EqualTo(typeof(PaginatedData<GetDomain>)));
    }
}